// This is the header file for the stage convenience functions, if you use these
// DO NOT use the PI qflx primatives, these functions do internal housekeeping
// and maintain an image of the origin separate from the qflx functions, if you
// access the qflx functions then there will be a discrepency and position errors
// WILL RESULT........
// matt December 1999

#ifndef __S_MAIN__
#define __S_MAIN__

#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <unistd.h>
#include <signal.h>
#include "linux_stage.h"
using namespace std;

#ifndef BYTE
#define BYTE	unsigned char
#endif

#ifndef TRUE
#define 	TRUE  1
#define 	FALSE 0
#endif

#ifndef BOOL
#define 	BOOL	int
#endif

#define		PI_WAIT 	1     //	TRUE
#define		PI_NO_WAIT	0     //	FALSE
#define 	PI_ORIGIN_FILE_NAME	"/etc/stages/PI_stage_origin"
#define 	PI_LOCKFILE		"/etc/stages/PI_stage_lock"
#define 	PI_LOCKFILEDIR		"/etc/stages"
#define 	PI_REPORT_LENGTH  	128
#define 	PI_CPM_O 	16.891102
#define 	PI_MPC_O 	0.059202768
#define 	PI_CPM_N 	118.567901
#define 	PI_MPC_N 	0.008433985
#define	 	PI_NO_MOVEMENT	0.0001
#define 	PI_SAMPLE_WAIT	1000	//1000 us

// define some ball park figures for these value (grey stages)
// undershoot=distance required to get moving at a decent rate
#define		PI_UNDERSHOOT	30
// overshoot=distance past position to ensure you get past a marker
#define		PI_OVERSHOOT	30
// backlash approximate difference between the actual position and the 'stage' position
// approached from different directions, note that this is <2microns for black stages
// but subject to a 'timing' error, ie error=velocity*time_lag, pretty much constant
// in one direction but changes sign for bidirectional scanning
#define		PI_BACKLASH	10

#define 	SW_MV 1000
#define		AXIS	int
#define		POS	float

//	house keeping functions
void 	PI_setup_stage(int);
void 	PI_close_stage(void);
//void 	PI_set_origin(POS,POS,POS,POS);
void 	PI_set_origin(void);
void 	PI_set_origin(AXIS);
void 	PI_init_limits(int,int,int,int);
BOOL 	PI_limit_ok(void);
void	PI_move_off_limits(void);
void	PI_move_off_limit_switches(void);
void 	PI_save_origin(void);
void	PI_recall_origin(void);
void 	PI_save_origin(char *);
void	PI_recall_origin(char *);
BOOL   	PI_axis_is_on(AXIS);
BYTE 	PI_get_limit_status(void);
void 	PI_get_position_and_error(POS *, POS *);	
void 	PI_get_position_and_error(AXIS ,POS *,POS *);
BOOL	PI_moving(AXIS);
void 	PI_pstat(AXIS);    

//user functions
void 	PI_moveto(POS,POS,POS,POS,BOOL);
void 	PI_moveto(AXIS,POS,BOOL);
void 	PI_shift(POS,POS,POS,POS,BOOL);
void 	PI_shift(AXIS,POS,BOOL);
void 	PI_set_velocity(AXIS, float);
void 	PI_get_position(POS *);	
float 	PI_get_position(AXIS);
float 	PI_get_position_NOW(AXIS);
BYTE 	PI_any_axis_moving(void);
void 	PI_wait_all_stop(void);
void 	PI_wait_axis_stop(AXIS);
void 	PI_stop_dead(void);
	
int   	PI_gtz(int);


#endif
